const state = {
  // 基本信息
  basicInfo: {
    // "examId": "考试ID",
    // "courseCode": "课程代码",
    // "courseName": "课程名称",
    // "paperNumber": "试卷编号",
    // "groupStatus": true,
    // "markMode": "评卷模式",
    // "cardId":"题卡ID"
  },
  // 试卷结构是否可编辑
  structureCanEdit: false,
  // 试卷结构
  paperStructureInfo: [],
  // 主观题任务列表
  subjectiveTaskList: [],
  // 是否开启分班阅
  openClassMark: false,
  // 填空题是否合并设置评卷员
  openMergeMarker: false,
  // 是否开启双评
  openDoubleMark: false,
  // 分班阅卷班级信息
  classInfo: [],
  // 客观题结构
  objectiveStructure: [],
  // 主观题标答
  subjectiveAnswer: [],
};

const mutations = {
  setBasicInfo(state, basicInfo) {
    state.basicInfo = basicInfo;
  },
  setPaperStructureInfo(state, paperStructureInfo) {
    state.paperStructureInfo = paperStructureInfo;
  },
  setStructureCanEdit(state, structureCanEdit) {
    state.structureCanEdit = structureCanEdit;
  },
  setSubjectiveTaskList(state, subjectiveTaskList) {
    state.subjectiveTaskList = subjectiveTaskList;
  },
  updateSubjectiveTaskItem(state, subjectiveTaskItem) {
    const pos = state.subjectiveTaskList.findIndex(
      (item) => item.id === subjectiveTaskItem.id
    );
    if (pos === -1) return;

    state.subjectiveTaskList.splice(
      pos,
      1,
      Object.assign({}, state.subjectiveTaskList[pos], subjectiveTaskItem)
    );
  },
  setOpenClassMark(state, openClassMark) {
    state.openClassMark = openClassMark;
  },
  setOpenMergeMarker(state, openMergeMarker) {
    state.openMergeMarker = openMergeMarker;
  },
  setOpenDoubleMark(state, openDoubleMark) {
    state.openDoubleMark = openDoubleMark;
  },
  setClassInfo(state, classInfo) {
    state.classInfo = classInfo;
  },
  setObjectiveAnswerInfo(state, objectiveAnswerInfo) {
    state.objectiveAnswerInfo = objectiveAnswerInfo;
  },
  setSubjectiveAnswer(state, subjectiveAnswer) {
    state.subjectiveAnswer = subjectiveAnswer;
  },
  initStore(state) {
    state.basicInfo = {};
    state.structureCanEdit = false;
    state.paperStructureInfo = [];
    state.subjectiveTaskList = [];
    state.openClassMark = false;
    state.openMergeMarker = false;
    state.openDoubleMark = false;
    state.classInfo = [];
    state.objectiveStructure = [];
    state.subjectiveAnswer = [];
  },
};

export default {
  namespaced: true,
  state,
  mutations,
};
